# Class HtmlExtractor

java.lang.Object
org.apache.jmeter.testelement.AbstractTestElement
org.apache.jmeter.testelement.AbstractScopedTestElement
org.apache.jmeter.extractor.HtmlExtractor

All Implemented Interfaces:
  `Serializable, Cloneable, Searchable, PostProcessor, TestElement`

public class HtmlExtractor extends AbstractScopedTestElement implements PostProcessor, Serializable

See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_EXTRACTOR`
`static final String`
`EXTRACTOR_JODD`
`static final String`
`EXTRACTOR_JSOUP`

### Fields inherited from interface TestElement

`COMMENTS, ENABLED, GUI_CLASS, NAME, TEST_CLASS`

## Constructor Summary

Constructors
Constructor
Description
`HtmlExtractor()`

## Method Summary

Modifier and Type
Method
Description
`String`
`getAttribute()`
`String`
`getDefaultValue()`
Get the default value for the variable if no matches are found
`String`
`getExpression()`
`String`
`getExtractor()`
Get the name of the currently configured extractor
`static final Extractor`
`getExtractorImpl(String impl)`
`static String[]`
`getImplementations()`
Get the possible extractor implementations
`int`
`getMatchNumber()`
`String`
`getMatchNumberAsString()`
`String`
`getRefName()`
`void`
`process()`
Parses the response data using CSS/JQuery expressions and saving the results into variables for use later in the test.
`void`
`setAttribute(String attribute)`
`void`
`setDefaultValue(String defaultValue)`
Sets the value of the variable if no matches are found
`void`
`setExpression(String regex)`
`void`
`setExtractor(String attribute)`
Set the extractor.
`void`
`setMatchNumber(int matchNumber)`
Set which Match to use.
`void`
`setMatchNumber(String matchNumber)`
`void`
`setRefName(String refName)`

### Methods inherited from class AbstractScopedTestElement

`fetchScope, getSampleList, getScopeName, getVariableName, isScopeAll, isScopeChildren, isScopeParent, isScopeVariable, isScopeVariable, setScopeAll, setScopeChildren, setScopeParent, setScopeVariable`

### Methods inherited from class AbstractTestElement

`addPropertiesValues, addProperty, addProperty, addTestElement, canRemove, clear, clearTemporary, clearTestElementChildren, clone, emptyTemporary, equals, getComment, getName, getProperty, getPropertyAsBoolean, getPropertyAsBoolean, getPropertyAsDouble, getPropertyAsFloat, getPropertyAsInt, getPropertyAsInt, getPropertyAsLong, getPropertyAsLong, getPropertyAsString, getPropertyAsString, getSearchableTokens, getThreadContext, getThreadName, hashCode, isEnabled, isRunningVersion, isTemporary, logProperties, mergeIn, propertyIterator, recoverRunningVersion, removeProperty, setComment, setEnabled, setName, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setRunningVersion, setTemporary, setThreadContext, setThreadName, traverse, traverseCollection, traverseMap, traverseProperty`

### Methods inherited from class Object

`finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### EXTRACTOR_JSOUP

public static final String EXTRACTOR_JSOUP

See Also:
  - Constant Field Values

### EXTRACTOR_JODD

public static final String EXTRACTOR_JODD

See Also:
  - Constant Field Values

### DEFAULT_EXTRACTOR

public static final String DEFAULT_EXTRACTOR

See Also:
  - Constant Field Values

## Constructor Details

### HtmlExtractor

public HtmlExtractor()

## Method Details

### getImplementations

public static String[] getImplementations()
Get the possible extractor implementations

Returns:
  Array containing the names of the possible extractors.

### process

public void process()
Parses the response data using CSS/JQuery expressions and saving the results into variables for use later in the test.

Specified by:
  `process` in interface `PostProcessor`
See Also:
  - `PostProcessor.process()`

### getExtractorImpl

public static final Extractor getExtractorImpl(String impl)

Parameters:
  `impl` - Extractor implementation
Returns:
  Extractor

### setExtractor

public void setExtractor(String attribute)
Set the extractor. Has to be one of the list that can be obtained by `getImplementations()`

Parameters:
  `attribute` - The name of the extractor to be used

### getExtractor

public String getExtractor()
Get the name of the currently configured extractor

Returns:
  The name of the extractor currently used

### setAttribute

public void setAttribute(String attribute)

### getAttribute

public String getAttribute()

### setExpression

public void setExpression(String regex)

### getExpression

public String getExpression()

### setRefName

public void setRefName(String refName)

### getRefName

public String getRefName()

### setMatchNumber

public void setMatchNumber(int matchNumber)
Set which Match to use. This can be any positive number, indicating the exact match to use, or `0`, which is interpreted as meaning random.

Parameters:
  `matchNumber` - The number of the match to be used

### setMatchNumber

public void setMatchNumber(String matchNumber)

### getMatchNumber

public int getMatchNumber()

### getMatchNumberAsString

public String getMatchNumberAsString()

### setDefaultValue

public void setDefaultValue(String defaultValue)
Sets the value of the variable if no matches are found

Parameters:
  `defaultValue` - The default value for the variable

### getDefaultValue

public String getDefaultValue()
Get the default value for the variable if no matches are found

Returns:
  The default value for the variable